// Updates: 2004.01.27, 2004.01.21


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;


/**
 * This program replaces all the characters containing an accent by their html 
 * code.<br><br>
 * Launch this application and then drag and drop the files you want to treat.
 */
public class AccentsToHtml extends JFrame implements DropTargetListener {
  private TextZone tz;
  
  
  public AccentsToHtml() {
    super("Accents To HTML");
    JPanel p = new JPanel(new BorderLayout());
    tz = new TextZone(this);
    p.add(tz);
    getContentPane().add(p);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);    
    setSize(250, 250);
    setLocationRelativeTo(null);
/*
    try {
      UIManager.setLookAndFeel("com.incors.plaf.kunststoff.KunststoffLookAndFeel");
    }
    catch (Exception e) {System.out.println(e);}
    SwingUtilities.updateComponentTreeUI(this);
*/    
    show();
  }


  public static void main(String[] args) {
    new AccentsToHtml();
  }
 

  public void drop(DropTargetDropEvent event) {
    event.acceptDrop(DnDConstants.ACTION_COPY);
    Transferable transferable = event.getTransferable();
    DataFlavor[] flavors = transferable.getTransferDataFlavors();
    tz.append("Treatement of:");
    for (int i = 0; i < flavors.length; i++) { 
      DataFlavor df = flavors[i];
      try {
        if (df.equals(DataFlavor.javaFileListFlavor)) {
          java.util.List fileList = (java.util.List)transferable.getTransferData(df);
          Iterator iterator = fileList.iterator();
          while (iterator.hasNext()) {
            File f = (File)iterator.next();
            String filename = f.toString();
            if (!filename.toLowerCase().endsWith(".html") && 
                !filename.toLowerCase().endsWith(".htm") &&
                !filename.toLowerCase().endsWith(".jsp")) {
              int returnVal = JOptionPane.showConfirmDialog(this, "Treat " + filename + "?", "Confirmation", JOptionPane.YES_NO_OPTION);
              if (returnVal == JOptionPane.NO_OPTION) continue;
            }
            tz.append(filename);
            treat(f);
          }
        }
      }
      catch(Exception e) { 
        tz.append("Error: " + e);
      }
    }
    tz.append("Done.\n");
    event.dropComplete(true);
  }

  
  public void dragEnter(DropTargetDragEvent event) {}
  public void dragExit(DropTargetEvent event) {}
  public void dragOver(DropTargetDragEvent event) {}
  public void dropActionChanged(DropTargetDragEvent event) {}
  
  
  private void treat(File f) {
    int size = (int)f.length ();
    char cbuf[] = new char[size];
    try {
      FileReader fr = new FileReader(f);    
      fr.read(cbuf);
      fr.close();
      new File("./BAK").mkdir();
      FileWriter fw = new FileWriter("./BAK/" + f.getName());
      fw.write(cbuf);
      fw.close();      
    }
    catch(IOException e) {
      tz.append("Error: " + e);
    }
    String output = "";
    for (int i = 0; i < size; i++) {
      output += removeAccent(cbuf[i]);
    }
    try {
      FileWriter fw = new FileWriter(f);
      fw.write(output);
      fw.close();
    }
    catch(IOException e) {
      tz.append("Error: " + e);
    }
  }    
  
  private void writeFile(String filename, String text) {
    try {
      FileWriter fw = new FileWriter(filename);
      fw.write(text);
      fw.close();
    }
    catch(IOException ioe) {
      System.out.println(ioe);
    }
  }  
  
  private String removeAccent(char c) {
    if (c == '') return "&aacute;";
    if (c == '') return "&acirc;";
    if (c == '') return "&aelig;";
    if (c == '') return "&agrave;";
    if (c == '') return "&aring;";       
    if (c == '') return "&atilde;";
    if (c == '') return "&auml;";
    if (c == '') return "&ccedil;";
    if (c == '') return "&eacute;";
    if (c == '') return "&ecirc;";
    if (c == '') return "&egrave;";
    if (c == '') return "&euml;";
    if (c == '') return "&iacute;";
    if (c == '') return "&icirc;";
    if (c == '') return "&igrave;";
    if (c == '') return "&iuml;";
    if (c == '') return "&ntilde;";
    if (c == '') return "&oacute;";
    if (c == '') return "&ocirc;";
    if (c == '') return "&ograve;";
    if (c == '') return "&oslash;"; 
    if (c == '') return "&otilde;";
    if (c == '') return "&ouml;";
    if (c == '') return "&szlig;";
    if (c == '') return "&thorn;"; 
    if (c == '') return "&uacute;";
    if (c == '') return "&ucirc;";
    if (c == '') return "&ugrave;";
    if (c == '') return "&uuml;";
    if (c == '') return "&yacute;";
    if (c == '') return "&yuml;";
    return "" + c;
  }    
}